; #########################################################################

      .386
      .model flat,stdcall
      option casemap:none   ; case sensitive

; #########################################################################

      include windows.inc
      include user32.inc
      include kernel32.inc

      includelib user32.lib
      includelib kernel32.lib

; #########################################################################

; These two typedefs are the interesting bit, taken from MASM Programmer's
; Guide chapter 7.

F4PROTO TYPEDEF PROTO STDCALL :DWORD,:DWORD,:DWORD,:DWORD
F4PTR   TYPEDEF PTR F4PROTO


.data

pMsgBox F4PTR 0


.const

szCapt db "Indirect Invoke Example",0

szMsg1 db "Calling MessageBox through eax.",0

szMsg2 db "Calling MessageBox through memory location.",0

szDll  db "user32.dll",0

szFunc db "MessageBoxA",0


.code

start:

    ; -- get pointer to MessageBox function --

    invoke LoadLibrary, addr szDll
    test   eax, eax
    jz     @F

    invoke GetProcAddress, eax, addr szFunc
    test   eax, eax
    jz     @F

    mov    pMsgBox, eax


    ; -- invoke MessageBox indirectly through eax --

    invoke F4PTR PTR eax, 0, addr szMsg1, addr szCapt, MB_OK

    ; (you could also do assume eax:F4PTR and use just eax above)


    ; -- invoke MessageBox indirectly through pMsgBox --

    invoke pMsgBox, 0, addr szMsg2, addr szCapt, MB_OK


    ; -- exit --

  @@:
    invoke ExitProcess, 0

end start
